Package com.pixelmed.dicom

# Class SetOfDicomFiles

java.lang.Object
java.util.AbstractCollection<E>
java.util.AbstractSet<E>
java.util.HashSet<SetOfDicomFiles.DicomFile>
com.pixelmed.dicom.SetOfDicomFiles

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Iterable<SetOfDicomFiles.DicomFile>`, `Collection<SetOfDicomFiles.DicomFile>`, `Set<SetOfDicomFiles.DicomFile>`

public class SetOfDicomFiles extends HashSet<SetOfDicomFiles.DicomFile>

A class to describe a set of DICOM files and their features such as SOP Class, Instance and Transfer Syntax UIDs.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`SetOfDicomFiles.DicomFile`

## Constructor Summary

Constructors
Constructor
Description
`SetOfDicomFiles()`
Construct an empty set of DICOM files.
`SetOfDicomFiles(String[] paths)`
Construct a set of DICOM files from an array of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles(String[] paths, boolean keepList, boolean keepPixelData)`
Construct a set of DICOM files from an array of String path names by reading each file's metaheader, +/- entire attribute list, as necessary
`SetOfDicomFiles(AbstractList<String> paths)`
Construct a set of DICOM files from a list of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles(AbstractList<String> paths, boolean keepList, boolean keepPixelData)`
Construct a set of DICOM files from a list of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.

## Method Summary

Modifier and Type
Method
Description
`SetOfDicomFiles.DicomFile`
`add(File file)`
Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles.DicomFile`
`add(String fileName)`
Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles.DicomFile`
`add(String fileName, boolean keepList)`
Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles.DicomFile`
`add(String fileName, boolean keepList, boolean keepPixelData)`
Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.
`SetOfDicomFiles.DicomFile`
`add(String fileName, String sopClassUID, String sopInstanceUID, String transferSyntaxUID)`
Add a DICOM file with the specified attributes.
`AttributeList[]`
`getAttributeLists()`
Get the attribute lists for all files, if they were kept during creation.
`Set`
`getSetOfSOPClassUIDs()`
`static void`
`main(String[] arg)`
For testing, read all DICOM files and build a set of them.
`String`
`toString()`
Return a String representing this object's value.

### Methods inherited from class java.util.HashSet

`add, clear, clone, contains, isEmpty, iterator, remove, size, spliterator, toArray, toArray`

### Methods inherited from class java.util.AbstractSet

`equals, hashCode, removeAll`

### Methods inherited from class java.util.AbstractCollection

`addAll, containsAll, retainAll`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream, toArray`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Methods inherited from interface java.util.Set

`addAll, containsAll, equals, hashCode, removeAll, retainAll`

## Constructor Details

### SetOfDicomFiles

public SetOfDicomFiles(AbstractList<String> paths)

Construct a set of DICOM files from a list of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.

Parameters:
  `paths` - a list of String DICOM file names (e.g., a Vector or an ArrayList)

### SetOfDicomFiles

public SetOfDicomFiles(AbstractList<String> paths, boolean keepList, boolean keepPixelData)

Construct a set of DICOM files from a list of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.

Parameters:
  `paths` - a list of String DICOM file names (e.g., a Vector or an ArrayList)
  `keepList` - whether or not to keep the entire attribute list (excluding pixel data unless requested) memory resident
  `keepPixelData` - whether or not to keep the pixel data memory resident as well

### SetOfDicomFiles

public SetOfDicomFiles(String[] paths)

Construct a set of DICOM files from an array of String path names by reading each file's metaheader, +/- entire attribute list, as necessary.

Parameters:
  `paths` - an array of String DICOM file names

### SetOfDicomFiles

public SetOfDicomFiles(String[] paths, boolean keepList, boolean keepPixelData)

Construct a set of DICOM files from an array of String path names by reading each file's metaheader, +/- entire attribute list, as necessary

Parameters:
  `paths` - an array of String DICOM file names
  `keepList` - whether or not to keep the entire attribute list (excluding pixel data unless requested) memory resident
  `keepPixelData` - whether or not to keep the pixel data memory resident as well

### SetOfDicomFiles

public SetOfDicomFiles()

Construct an empty set of DICOM files.

## Method Details

### getSetOfSOPClassUIDs

public Set getSetOfSOPClassUIDs()

### toString

public String toString()

Return a String representing this object's value.

Overrides:
  `toString` in class `AbstractCollection<SetOfDicomFiles.DicomFile>`
Returns:
  a string representation of the value of this object

### add

public SetOfDicomFiles.DicomFile add(String fileName)

Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.

Keeps only the minimal descriptive attributes, and not the entire attribute list (including pixel data) memory resident.

Parameters:
  `fileName` - a DICOM file
Returns:
  the DicomFile added

### add

public SetOfDicomFiles.DicomFile add(File file) throws IOException

Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.

Keeps only the minimal descriptive attributes, and not the entire attribute list (including pixel data) memory resident.

Parameters:
  `file` - a DICOM file
Returns:
  the DicomFile added
Throws:
  `IOException`

### add

public SetOfDicomFiles.DicomFile add(String fileName, boolean keepList)

Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.

Parameters:
  `fileName` - a DICOM file
  `keepList` - whether or not to keep the entire attribute list memory resident
Returns:
  the DicomFile added

### add

public SetOfDicomFiles.DicomFile add(String fileName, boolean keepList, boolean keepPixelData)

Add a DICOM file by reading its metaheader, +/- entire attribute list, as necessary.

Parameters:
  `fileName` - a DICOM file
  `keepList` - whether or not to keep the entire attribute list (excluding pixel data unless requested) memory resident
  `keepPixelData` - whether or not to keep the pixel data memory resident as well
Returns:
  the DicomFile added

### add

public SetOfDicomFiles.DicomFile add(String fileName, String sopClassUID, String sopInstanceUID, String transferSyntaxUID)

Add a DICOM file with the specified attributes.

Parameters:
  `fileName` - a DICOM file
Returns:
  the DicomFile added

### getAttributeLists

public AttributeList[] getAttributeLists()

Get the attribute lists for all files, if they were kept during creation.

Returns:
  an array of attribute lists, each of which will be null unless keeplists was true when created

### main

public static void main(String[] arg)

For testing, read all DICOM files and build a set of them.

Parameters:
  `arg` - the filenames